// TömbBemutató - a tömbök használatának bemutatása
//                egész számok egy sorozatának beolvasásával
//                majd a számok és az összegük kiírásával
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// prototípusdeklarációk
int tombBeolvasasa(int egeszTomb[], int elemekMaxSzama);
int tombOsszegzese(int egeszTomb[], int elemekSzama);
void tombKiirasa(int egeszTomb[], int elemekSzama);

int main(int nArgSzama, char* mszArg[])
{
    // a használat leírása
    cout << "Ez a program összegzi az értékeket, "
         << "melyeket a felhasználó megad\n";
    cout << "A ciklus befejezéséhez adj meg "
         << "egy negatív számot\n";
    cout << endl;

    // kérjük be az összegzendő számokat a felhasználótól
    // egy helyi tömbbe
    int bemenetiErtekek[128];
    int ertekekSzama = tombBeolvasasa(bemenetiErtekek, 128);

    // most írjuk ki az értékeket és az értékek összegét
    tombKiirasa(bemenetiErtekek, ertekekSzama);
    cout << "Az összeg "
         << tombOsszegzese(bemenetiErtekek, ertekekSzama)
         << endl;

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
// tombBeolvasasa - egész számokat olvas be a kezelőtől az
//             'egeszTomb' tömbbe, amíg negatív számot nem ad meg
//             A tárolt elemek számát adja vissza.
int tombBeolvasasa(int egeszTomb[], int elemekMaxSzama)
{
    int ertekekSzama;
    for(ertekekSzama = 0;
        ertekekSzama < elemekMaxSzama;
        ertekekSzama++)
    {
        // a következő szám bekérése
        int egeszErtek;
        cout << "Add meg a következő számot: ";
        cin  >> egeszErtek;
        // ha negatív...

        if (egeszErtek < 0)
        {
            // ...akkor kilépünk
            break;
        }
        // ... Különben eltároljuk a számot
        // a tárolótömbben
        egeszTomb[ertekekSzama] = egeszErtek;
    }

    // a beolvasott elemek számának visszaadása
    return ertekekSzama;
 }

// tombKiirasa - kiírja egy tombMerete méretű
//                tömb tagjait
void tombKiirasa(int egeszTomb[], int elemekSzama)
{
    cout << "A tömb értéke:" << endl;
    for (int i = 0; i <= elemekSzama; i++)
    {
        cout << i << ": " << egeszTomb[i] << endl;
    }
    cout << endl;
}

// tombOsszegzese - egy egész tömb tagjainak összegét
//            adja vissza
int tombOsszegzese(int egeszTomb[], int elemekSzama)
{
    int gyujto = 0;
    for (int i = 0; i <= elemekSzama; i++)
    {
        gyujto += egeszTomb[i];
    }
    return gyujto;
}
