// LáncoltListaAdatok - adatok tárolása objektumok láncolt listájában
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
// NevAdathalmaz - egy személy nevét tárolja (ezekben az objektumokban
//                 könnyedén tárolhatnánk bármilyen más információt is
//                 igény szerint).
class NevAdathalmaz
{
  public:
    string szNev;
    // a lista következő bejegyzésének hivatkozása
    NevAdathalmaz* mKovetkezo;
};
// a lista első bejegyzésének mutatója
NevAdathalmaz* mFej = nullptr;
// hozzaadas - új tag hozzáadása a láncolt listához
void hozzaadas(NevAdathalmaz* mNA)
{
    // az aktuális bejegyzésben a lista elejére mutatunk
    mNA->mKovetkezo = mFej;
    // a fejmutatóval az aktuális bejegyzésre mutatunk
    mFej = mNA;
}
// adatokBeolvasasa - név és TAJ szám beolvasása;
//                    null-t ad vissza, ha már nincs mit beolvasni
NevAdathalmaz* adatokBeolvasasa()
{
    // beolvassuk az első nevet
    string nev;
    cout << "Add meg a nevet:";
    cin  >> nev;
    // ha a megadott név 'stop'...
    if (nev == "stop")
    {
        // ...null-t adunk vissza a bevitel befejezéséhez
        return nullptr;
    }
    // létrehozunk egy új bejegyzést és kitöltjük az értékeket
    NevAdathalmaz* mNA = new NevAdathalmaz;
    mNA->szNev = nev;
    mNA->mKovetkezo = nullptr; // üres hivatkozás
    // a létrehozott objektum címét adjuk vissza
    return mNA;
}
int main(int nArgSzama, char* mszArg[])
{
    cout << "Hallgatók nevének beolvasása\n"
         << "A kilépéshez add meg első névként, hogy 'stop'"
         << endl;
    // létrehozunk (még egy) NevAdathalmaz objektumot
    NevAdathalmaz* mNA;
    while (mNA = adatokBeolvasasa())
    {
        // hozzáadjuk a NevAdathalmaz objektumok listájához
        hozzaadas(mNA);
    }
    // az objektumok megjelenítéséhez végigiterálunk a
    // listán (akkor állunk le, ha a következő cím NULL)
    cout << "\nBejegyzések:" << endl;
    for(NevAdathalmaz *mIter = mFej;
                       mIter; mIter = mIter->mKovetkezo)
    {
        // kiírjuk az aktuális bejegyzés nevét
        cout << mIter->szNev << endl;
   }
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
