// LáncoltListaElőre - egy olyan láncolt lista, amely
//                     a lista végére szúrja be az új objektumokat
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string.h>
#define nullptr 0  // a nagyon régi fordítóprogramokhoz szükséges

using namespace std;

// NevAdathalmaz - egy személy nevét tárolja (ezekben az objektumokban
//                 könnyedén tárolhatnánk bármilyen más információt is
//                 igény szerint).
class NevAdathalmaz
{
  public:
    string szNev;
    // a lista következő bejegyzésének hivatkozása
    NevAdathalmaz* mKovetkezo;
};
// a lista első bejegyzésének mutatója
NevAdathalmaz* mFej = nullptr;
// hozzaadas - új tag hozzáadása a láncolt listához
//       (ez a verzió a lista végére szúrja be az
//       új tagokat)
void hozzaadas(NevAdathalmaz* mNA)
{
    // győződjünk meg róla, hogy a láncmutató null (mivel
    // ez lesz az utolsó tag)
    mNA->mKovetkezo = nullptr;

    // ha a lista üres...
    if (!mFej)
    {
        // ...legyen ez az első (és egyetlen illető
        // a listában, és kész vagyunk)
        mFej = mNA;
        return;
    }

    // ...máskülönben kapcsoljuk az utolsó illetőhöz a listában
    NevAdathalmaz* mIter = mFej;
    while(mIter->mKovetkezo)
    {
        mIter = mIter->mKovetkezo;
    }

    // now make that last guy point to us
    mIter->mKovetkezo = mNA;
}

// adatokBeolvasasa - név és TAJ szám beolvasása;
//                    null-t ad vissza, ha már nincs mit beolvasni
NevAdathalmaz* adatokBeolvasasa()
{
    // beolvassuk az első nevet
    string nev;
    cout << "Add meg a nevet:";
    cin  >> nev;
    // ha a megadott név 'stop'...
    if (nev == "stop")
    {
        // ...null-t adunk vissza a bevitel befejezéséhez
        return nullptr;
    }
    // létrehozunk egy új bejegyzést és kitöltjük az értékeket
    NevAdathalmaz* mNA = new NevAdathalmaz;
    mNA->szNev = nev;
    mNA->mKovetkezo = nullptr; // üres hivatkozás
    // a létrehozott objektum címét adjuk vissza
    return mNA;
}
int main(int nArgSzama, char* mszArg[])
{
    cout << "Hallgatók nevének beolvasása\n"
         << "A kilépéshez add meg első névként, hogy 'stop'"
         << endl;
    // létrehozunk (még egy) NevAdathalmaz objektumot
    NevAdathalmaz* mNA;
    while (mNA = adatokBeolvasasa())
    {
        // hozzáadjuk a NevAdathalmaz objektumok listájához
        hozzaadas(mNA);
    }
    // az objektumok megjelenítéséhez végigiterálunk a
    // listán (akkor állunk le, ha a következő cím NULL)
    cout << "\nBejegyzések:" << endl;
    for(NevAdathalmaz *mIter = mFej;
                       mIter; mIter = mIter->mKovetkezo)
    {
        // kiírjuk az aktuális bejegyzés nevét
        cout << mIter->szNev << endl;
   }
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
