//
//  TypeConversion - szemlélteti egy típus egy másikra történő
//                   implicit konverzióját;
//                   Ez a program a C++ 2011-es szabványától
//                   elérhető explicit kulcsszó használatát is bemutatja.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Komplex
{
  public:
    Komplex() : dValos(0.0), dImag(0.0)
    { cout << "alapértelmezett konstructor meghívása" << endl;}
    /*explicit*/ Komplex(double _dValos)
      : dValos(_dValos), dImag(0.0)
    { cout << "valós konstructor meghívása: " << dValos <<endl;}
    Komplex(double _dValos, double _dImag)
      : dValos(_dValos), dImag(_dImag)
    {
        cout << "komplex konstructor meghívása: " << dValos
             << ", " << dImag << endl;
    }

    double dValos;
    double dImag;
};

int main(int argszama, char* mArg[])
{
    Komplex k1, k2(1.0), k3(1.0, 1.0);

    // a konstructorral típusok közötti konverzió
    // végezhető
    k1 = Komplex(10.0);

    // a következő konverziók még akkor is működnek, ha az explicit
    // nincs kikommentelve
    k1 = (Komplex)20.0;
    k1 = static_cast<Komplex>(30.0);

    // a következő implicit konverziók csak akkor működnek,
    // ha az explicit ki van kommentelve
    k1 = 40.0;
    k1 = 50;

    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
