//
//  AlapértelmezettMásolóKonstruktor - bemutatja, hogy az alapértelmezett
//                                     másoló konstruktor minden tag
//                                     másoló konstruktorát meghívja
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Hallgato
{
  public:
    // hagyományos konstruktor
    Hallgato(const char *mNev = "névtelen", int khAzon = 0)
      : nev(mNev), azon(khAzon)
    { cout << nev << " felépítve" << endl; }
    // másoló konstruktor
    Hallgato(const Hallgato& h)
      : nev(h.nev + " másolata"), azon(h.azon)
    { cout << nev << " felépítve" << endl; }
    ~Hallgato() { cout << nev << " megsemmisítése" << endl; }
  protected:
    string nev;
    int azon;
};

class Konzulens
{
  public:
    Konzulens(Hallgato& h)
       : hallgato(h), azon(0)
    { cout << "Konzulens objektum létrehozása" << endl; }
  protected:
    Hallgato hallgato;
    int azon;
};
void fv(Konzulens konzulens)
{
    cout << "Az fv() függvényben" << endl;
}
int main(int argszama, char* mArg[])
{
    Hallgato bodri("Bodri");
    Konzulens konzulens(bodri);
    cout << "Az fv() meghívása" << endl;
    fv(konzulens);
    cout << "Újra a main() függvényben" << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

