// LáncoltListaOsztály - a láncolt listás példa osztálymetódusokkal
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// NevAdathalmaz - egy személy nevét tárolja (ezekben az objektumokban
//                 könnyedén tárolhatnánk bármilyen más információt is
//                 igény szerint).
class NevAdathalmaz
{
  public:
    NevAdathalmaz(string& hivNev)
      : szNev(hivNev), mKovetkezo(nullptr) {}
    // önmaga hozzáadása a lista elejéhez
    void hozzaadas()
    {
        this->mKovetkezo = mFej;
        mFej = this;
    }
    // lekérdező metódusok
    static NevAdathalmaz* elso() { return mFej; }
           NevAdathalmaz* kovetkezo()  { return mKovetkezo; }
          const string& nev()  { return szNev; }
  protected:
    string szNev;
    // a lista első és következő tagjának hivatkozása
    static NevAdathalmaz* mFej;
    NevAdathalmaz* mKovetkezo;
};

// tárhely lefoglalása a fejmutatónak
NevAdathalmaz* NevAdathalmaz::mFej = nullptr;


// adatokBeolvasasa - név és TAJ szám beolvasása;
//                    null-t ad vissza, ha már nincs mit beolvasni
NevAdathalmaz* adatokBeolvasasa()
{
    // beolvassuk az első nevet
    string nev;
    cout << "Add meg a nevet:";
    cin  >> nev;
    // ha a megadott név 'stop'...
    if (nev == "stop")
    {
        // ...null-t adunk vissza a bevitel befejezéséhez
        return 0;
    }

    // máskülönben egy objektumot adunk vissza a megadott névvel
    return new NevAdathalmaz(nev);
}

int main(int nArgSzama, char* mszArg[])
{
    cout << "Hallgatók nevének beolvasása\n"
         << "A kilépéshez add meg első névként, hogy 'stop'"
         << endl;

    // létrehozunk (még egy) NevAdathalmaz objektumot
    NevAdathalmaz* mNA;
    while (mNA = adatokBeolvasasa())
    {
        // hozzáadjuk a NevAdathalmaz objektumok listájához
        mNA->hozzaadas();
    }

    // az objektumok megjelenítéséhez végigiterálunk a
    // listán (akkor állunk le, ha a következő cím NULL)
    cout << "\nBejegyzések:" << endl;
    for(NevAdathalmaz *mIter = NevAdathalmaz::elso();
        mIter;
        mIter = mIter->kovetkezo())
    {
        // kiírjuk az aktuális bejegyzés nevét
        cout << mIter->nev() << endl;
   }

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
