// StatikusTagMeghívása - két módszert szemléltet
//                        egy statikus tagfüggvény meghívására
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    Hallgato(const char* mN = "névtelen") : szNev(mN)
    {
        hallgatokSzama++;
    }
    ~Hallgato() { hallgatokSzama--; }
    const string& nev() { return szNev; }
    static int szam() { return hallgatokSzama; }
  protected:
    string szNev;
    static int hallgatokSzama;
};
int Hallgato::hallgatokSzama = 0;
int main(int argszama, char* mArg[])
{
    // létrehozunk két hallgatót, aztán megkérdezzük az osztálytól, hogy "mennyi?"
    Hallgato h1("Buksi");
    Hallgato* mH2 = new Hallgato("Csöpi");
    cout << h1.nev() << " és "
         << mH2->nev()    << " létrehozva" << endl;
    cout << "A hallgatók száma "
         << h1.szam() << endl;
    // most szabaduljunk meg egy hallgatótól, és kérdezzünk rá még egyszer
    cout << mH2->nev() << " törlése" << endl;
    delete mH2;
    cout << "A hallgatók száma "
         << Hallgato::szam() << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
