//  ÖröklésiPélda - bemutat egy öröklési
//                  kapcsolatot, amelyben az alosztály
//                  konstruktora átadja az argumentumadatokat
//                  az alaposztály konstruktorának
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Temavezeto {}; // egy üres osztályt definiálunk

class Hallgato
{
  public:
    Hallgato(const char *mNev = "névtelen")
       : nev(mNev), atlag(0.0), feleviOraszam(0)
    {
        cout << "A következő hallgató felépítése: " << nev << endl;
    }
    void kurzusHozzaadasa(int oraszam, float osztalyzat)
    {
        cout << nev << "osztályzatának hozzáadása" << endl;
        atlag = feleviOraszam * atlag + osztalyzat;
        feleviOraszam += oraszam;
        atlag = atlag / feleviOraszam;
    }

    int oraszam() { return feleviOraszam;}
    float tanulmanyiAtlag() { return atlag;}
  protected:
    string nev;
    double atlag;
    int    feleviOraszam;
};

class VegzosHallgato : public Hallgato
{
  public:
    VegzosHallgato(const char *mNev, Temavezeto tem,
                    double mO = 0.0)
        : Hallgato(mNev), temavezeto(tem), minositoOsztalyzat(mO)
    {
        cout << "A következő végzős hallgató felépítése: "
             << mNev << endl;
    }
    double minosito() { return minositoOsztalyzat; }

  protected:
    Temavezeto temavezeto;
    double minositoOsztalyzat;
};
int main(int nArgSzama, char* mszArg[])
{

    // létrehozunk egy üres témavezetőt, amelyet megkap a VegzosHallgato
    Temavezeto tem;

    // létrehozunk két Hallgato típust
    Hallgato hll("Czudar Sára");
    VegzosHallgato vh("Molnár Márton", tem, 1.5);
    // most hozzáadunk egy osztályzatot a tanulmányi átlagukhoz
    hll.kurzusHozzaadasa(3, 2.5);
    vh.kurzusHozzaadasa(3, 3.0);

    // kiírjuk a végzős hallgató minősítő osztályzatát
    cout << "Márton minősítő osztályzata = "
         << vh.minosito() << endl;

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
