//ÉrtékadóOperátorBemutató - bemutatja az értékadó operátor
//                           használatát egy felhasználó által definiált osztályban
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
// DTomb - egy dinamikus méretű tömbosztály, amellyel
//         bemutatjuk az értékadó és a másoló konstruktor
//         operátort
class DTomb
{
  public:
    DTomb(int nTombHossza = 0)
      : nHossz(nTombHossza), mTomb(nullptr)
    {
        cout << "DTomb létrehozása, hossz = "
             << nHossz << endl;
        if (nHossz > 0)
        {
            mTomb = new int[nHossz];
        }
    }
    DTomb(DTomb& dt)
    {
        cout << "DTomb másolása, hossz = "
             << dt.nHossz << endl;
        dTombMasolas(dt);
    }
    ~DTomb()
    {
        dTombTorles();
    }
    //értékadó operátor
    DTomb& operator=(const DTomb& s)
    {
        cout << "Forrás hozzárendelése (hossz = "
             << s.nHossz
             << ") a célhoz (hossz = "
             << this->nHossz << ")" << endl;
        //töröljünk a meglévő cuccokat...
        dTombTorles();
        //...Mielőtt lecseréljük az új cuccokra
        dTombMasolas(s);
        //visszaadjuk a meglévő objektum hivatkozását
        return *this;
    }
    int& operator[](int index)
    {
        return mTomb[index];
    }
    int meret() { return nHossz; }
    void megjelenites(ostream& ki)
    {
        if (nHossz > 0)
        {
            ki << mTomb[0];
            for (int i = 1; i < nHossz; i++)
            {
                ki << ", " << mTomb[i];
            }
        }
    }
  protected:
    void dTombMasolas(const DTomb& dt);
    void dTombTorles();
    int nHossz;
    int* mTomb;
};
//dTombMasolas() - másolatot készít egy dinamikus int tömbről
void DTomb::dTombMasolas(const DTomb& forras)
{
    nHossz = forras.nHossz;
    mTomb = nullptr;
    if (nHossz > 0)
    {
        mTomb = new int[nHossz];
        for (int i = 0; i < nHossz; i++)
        {
            mTomb[i] = forras.mTomb[i];
        }
    }
}
//dTombTorles() - felszabadítjuk a halommemóriát
void DTomb::dTombTorles()
{
    nHossz = 0;
    delete mTomb;
    mTomb = nullptr;
}
int main(int nArgSzama, char* mszArg[])
{
    // létrehozunk egy dinamikus tömböt, és értékeket rendelünk hozzá
    DTomb dt1(5);
    for (int i = 0; i <= dt1.meret(); i++)
    {
        // a felhasználó által definiált index operátorral
        // éri el a tömb tagjait
        dt1[i] = i;
    }
    cout << "dt1="; dt1.megjelenites(cout); cout << endl;
    // most létrehozzuk ennek a dinamikus tömbnek a másolatát
    // a másoló konstruktorral; ez ugyanaz, mint a dt2(dt1)
    DTomb dt2 = dt1;
    dt2[2] = 20;   // a másolatban módosítunk egy értéket
    cout << "dt2="; dt2.megjelenites(cout); cout << endl;
    // felülírjuk a meglévő dt2-t az eredeti dt1-gyel
    dt2 = dt1;
    cout << "dt2="; dt2.megjelenites(cout); cout << endl;

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
