// FájlMásolás - biztonsági másolatot készít a programnak
//               átadott fájlokról
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
using namespace std;
int main(int nArgSzama, char* mszArg[])
{
    // minden átadott fájlnál megismételjük a folyamatot
    for (int n = 1; n < nArgSzama; n++)
    {
        // létrehozzuk a fájlnevet és a ".biztonsági" nevet
        string szForras(mszArg[n]);
        string szCel = szForras + ".biztonsági";
        // most megnyitjuk a forrást olvasásra, a
        // célt pedig írásra
        ifstream bemenet(szForras.c_str(),
                       ios_base::in|ios_base::binary);
        ofstream kimenet(szCel.c_str(),
          ios_base::out|ios_base::binary|ios_base::trunc);
        if (bemenet.good() && kimenet.good())
        {
            cout << szForras << " biztonsági mentése" << "...";
            // addig olvassuk be és írjuk a 4KB-os blokkokat, amíg
            // nem történik hiba vagy el nem érjük a fájl végét (EOF)
            while(!bemenet.eof() && bemenet.good())
            {
                char puffer[4096];
                bemenet.read(puffer, 4096);
                kimenet.write(puffer, bemenet.gcount());
            }
            cout << "kész" << endl;
        }
        else
        {
            cerr << szForras << "másolása nem sikerült" << endl;
        }
    }
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
