// SztringAdatfolyam - egy fájl tartalmát olvassa be és elemzi
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <sstream>
#include <iostream>
using namespace std;
// szamlaAdatokElemzese - egy átadott puffert olvas be úgy, mintha
//               tényleges fájl lenne - az következő
//               formátumot olvassa be:
//                név, számlaszám egyenleg
//               siker esetén true értéket ad vissza
bool sztringElemzes(const char* mSztring,
                 char* mNev, int tombMeret,
                 long& szamlaSzam, double& egyenleg)
{
    // egy istrstream objektumot rendelünk a bemeneti
    // karaktersztringhez
    istringstream be(mSztring);
    // az elválasztó vesszőig olvasunk
    be.getline(mNev, tombMeret, ',');
    // most jön a számlaszám
    be >> szamlaSzam;
    // majd az egyenleg
    be >> egyenleg;
    // visszaadjuk a hibaállapotot
    return !be.fail();
}
int main(int nArgSzama, char* mszArg[])
{
    // meg kell adni a fájlnevet
    char szFajlnev[128];
    cout << "Add meg az elemzendő fájl nevét:";
    cin.getline(szFajlnev, 128);
    // beolvasunk egy fájladatfolyamot
    ifstream* mFajlAdatfolyam = new ifstream(szFajlnev);
    if (!mFajlAdatfolyam->good())
    {
        cerr << mszArg[1] << "nem nyitható meg" << endl;
        return 0;
    }
    // beolvasunk egy sort a fájlból, elemezzük és kiírjuk
    // az eredményeket
    for(int nSorszam = 1;;nSorszam++)
    {
        // beolvasunk egy puffert
        char puffer[256];
        mFajlAdatfolyam->getline(puffer, 256);
        if (mFajlAdatfolyam->fail())
        {
            break;
        }
        cout << nSorszam << ":" << puffer << endl;
        // elemezzük az egyes mezőket
        char nev[80];
        long szamlaSzam;
        double egyenleg;
        bool eredmeny = sztringElemzes(puffer, nev, 80,
                                  szamlaSzam, egyenleg);
        if (eredmeny == false)
        {
            cerr << "Hiba történt a sztring elemzése során\n" << endl;
            continue;
        }
        // kiírjuk a kinyert mezőket
        cout << "A beolvasott mezők a következők:" << endl;
        cout << "  név = " << nev << "\n"
             << "  számla = " << szamlaSzam << "\n"
             << "  egyenleg = " << egyenleg << endl;
        // újból összeillesztjük a mezőket más
        // sorrendben (az 'ends' beszúrásával biztosítjuk, hogy
        // a puffer ne nullal záruljon
        ostringstream ki;
        ki << nev << ", "
            << egyenleg << " "
            << szamlaSzam << ends;
        string kiSztring = ki.str();
        cout << "Átrendezett mezők: " << kiSztring << endl;
    }
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
