//
//  EgyéniKivételOsztály - szemlélteti a kivételkezelési
//              mechanizmus rugalmasságát egy egyéni
//              kivételosztály létrehozásával
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <sstream>
using namespace std;
// EnKivetelem - általános kivételkezelő osztály
class EnKivetelem
{
  public:
    EnKivetelem(const char* mUzenet, int n,
                const char* mFv,
                const char* mFajl, int nSor)
      : uzenet(mUzenet), hibaErtek(n),
        fvNev(mFv), fajl(mFajl), sorSzam(nSor){}
    virtual string megjelenites()
    {
        ostringstream ki;
        ki << "Hiba <" << uzenet << ">"
            << " - az érték " << hibaErtek << "\n"
            << "függvény: " << fvNev << "()\n"
            << "fájl: " << fajl
            << ", sorszám: " << sorSzam << ends;
        return ki.str();
    }
  protected:
    // hibaüzenet
    string uzenet;
    int    hibaErtek;
    // függvénynév, fájlnév és sorszám
    // ahol a hiba történt
    string fvNev;
    string fajl;
    int sorSzam;
};
// faktorialis - kiszámítja a faktoriálist
int faktorialis(int n) throw(EnKivetelem)
{
    // nem tudjuk kezelni, ha az n értéke negatív;
    // jobb, ha előbb ellenőrizzük ezt a feltételt
    if (n < 0)
    {
        throw EnKivetelem("A negatív argumentum nem engedélyezett",
                        n, __func__, __FILE__, __LINE__);
    }
    // továbblépünk, és kiszámítjuk a faktoriálist
    int gyujto = 1;
    while(n > 0)
    {
        gyujto *= n;
        n--;
    }
    return gyujto;
}
int main(int nArgSzama, char* mszArg[])
{
    try
    {
        // ez működni fog
        cout << "A 3 faktoriális értéke "
             << faktorialis(3) << endl;
        // ez kivételt fog generálni
        cout << "A -1 faktoriális értéke "
             << faktorialis(-1) << endl;
        // a vezérlés soha nem fog eljutni ide
        cout << "Az 5 faktoriális értéke "
             << faktorialis(5) << endl;
    }
    // a vezérlés ide kerül át
    catch(EnKivetelem e)
    {
        cout << e.megjelenites() << endl;
    }
    catch(...)
    {
        cout << "Alapértelmezett kezelés " << endl;
    }
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
