// SablonVektor - egy olyan vektort valósít meg, amely
//                sablontípust használ
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include "sablonvektor.h"
using namespace std;
// intFv() - egészek egy készletét kezeli
void intFv()
{
    // létrehozunk egy egészekből álló vektort
    SablonVektor<int> egeszek(10);
    // értékeket adunk hozzá a vektorhoz
    cout << "Add meg az egész értékeket, melyeket hozzá szeretnél adni a vektorhoz\n"
         << "(A befejezéshez adj meg egy negatív értéket):"
         << endl;
    for(;;)
    {
        int n;
        cin  >> n;
        if (n < 0) { break; }
        egeszek.hozzaadas(n);
    }
    cout << "\nA következő számokat adtad meg:" << endl;
    for(int i = 0; i < egeszek.meret(); i++)
    {
        cout << i << ":" << egeszek.lekeres() << endl;
    }
}
// Nevek - egy neveket tartalmazó vektort hoz létre és kezel
class Nev
{
  public:
    Nev() = default;
    Nev(string s) : nev(s) {}
    const string& megjelenites() { return nev; }
  protected:
    string nev;
};
void nevFv()
{
    // létrehozunk egy Nev objektumokból álló vektort
    SablonVektor<Nev> nevek(20);
    // értékeket adunk hozzá a vektorhoz
    cout << "Add meg a neveket, melyeket hozzá szeretnél adni a második vektorhoz\n"
         << "(A kilépéshez adj meg egy 'x'-et):" << endl;
    for(;;)
    {
        string s;
        cin >> s;
        if (s == "x" || s == "X") { break; }
        nevek.hozzaadas(Nev(s));
    }
    cout << "\nA következő neveket adtad meg" << endl;
    for(int i = 0; i < nevek.meret(); i++)
    {
        Nev& nev = nevek.lekeres();
        cout << i << ":" << nev.megjelenites() << endl;
    }
}
int main(int argszama, char* mArg[])
{
    intFv();
    nevFv();
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
