// SablonVektor - egy sablonalapú vektorosztály
//                inicializáló listával
#include <initializer_list>
template <class T>
class SablonVektor
{
  public:
    SablonVektor(int nTombMeret)
    {
        // tároljuk az elemek számát
        nMeret = nTombMeret;
        tomb = new T[nTombMeret];
        visszaallitas();
    }
    SablonVektor(const std::initializer_list<T> il) :
        SablonVektor(il.size())
    {
        // az il tartalmát a vektorba másoljuk
        for(const T* m = il.begin(); m < il.end(); m++)
        {
            hozzaadas(*m);
        }
    }

    int meret() { return nIrasiIndex; }
    void visszaallitas() { nIrasiIndex = 0; nOlvasasiIndex = 0; }
    void hozzaadas(const T& objektum)
    {
        if (nIrasiIndex < nMeret)
        {
            tomb[nIrasiIndex++] = objektum;
        }
    }
    T& lekeres()
    {
        return tomb[nOlvasasiIndex++];
    }

  protected:
    int nMeret;
    int nIrasiIndex;
    int nOlvasasiIndex;
    T* tomb;
};
