// STLHallgatoLista - egy listában tárol és rendez egy
//                    felhasználó által definiált osztályt
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <list>
using namespace std;
// Hallgato - egy példa a felhasználó által definiált osztályokra
class Hallgato
{
  public:
    Hallgato(const char* mszH, int azon)
      : szNev(mszH), khAzon(azon) {}
    string szNev;
    int khAzon;
};
// az alábbi függvény szükséges a
// rendezési művelet támogatásához
bool operator<(const Hallgato& h1,const Hallgato& h2)
{
    return h1.khAzon < h2.khAzon;
}
// hallgatokMegjelenitese - bejárja a listát, és megjeleníti
//                          az egyes elemeket
void hallgatokMegjelenitese(list<Hallgato>& hallgatok)
{
    // egy olyan iterátort foglalunk le, amely egy lista
    // első elemére mutat
    // list<Hallgato>::iterator iter = hallgatok.begin();
    auto iter = hallgatok.begin();
    // addig haladunk végig a listán a ciklusban, amíg
    // az iterátor el nem éri a lista végét
    while(iter != hallgatok.end())
    {
        // lekérjük azt a Hallgato objektumot, amelyre az iterátor mutat
        Hallgato& h = *iter;
        cout << h.khAzon << " - " << h.szNev << endl;
        // most áthelyezzük az iterátort a következő elemre
        // a listában
        iter++;
    }
}
int main(int argszama, char* mArg[])
{
    // definiálunk egy hallgatókból álló kollekciót
    list<Hallgato> hallgatok;
    // hozzáadunk három hallgató objektumot a listához
    hallgatok.push_back(Hallgato("Sebes Mária", 10));
    hallgatok.push_back(Hallgato("Trükkös Tomi", 5));
    hallgatok.push_back(Hallgato("Hallga Tóni", 15));
    // kiírjuk a listát
    cout << "Az eredeti lista:" << endl;
    hallgatokMegjelenitese(hallgatok);
    // most rendezzük a listát, és újból kiírjuk
    hallgatok.sort();
    cout << "\nA rendezett lista:" << endl;
    hallgatokMegjelenitese(hallgatok);
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
