// STLSztring - szemléltet néhányat a szabványos
//              sablonkönyvtárban található string
//              osztály funkciói közül
#include <cstdlib>
#include <cstdio>
#include <iostream>
using namespace std;
// szokozokTorlese - eltávolít minden szóközt egy sztringből
string szokozokTorlese(const string& forras)
{
    // másolatot készítünk a forrássztringről, hogy ne
    // módosítsuk azt
    string sz = forras;
    // megkeressük az első szóköz eltolását;
    // addig keresünk a sztringben, amíg nem találunk több szóközt
    size_t eltolas;
    while((eltolas = sz.find(" ")) != string::npos)
    {
        // eltávolítjuk az imént megtalált szóközt
        sz.erase(eltolas, 1);
    }
    return sz;
}
// kifejezesBeszuras - beszúr egy kifejezést a
//                     <bp> mint beszúrási pont helyére
string kifejezesBeszuras(const string& forras)
{
    string sz = forras;
    size_t eltolas = sz.find("<bp>");
    if (eltolas != string::npos)
    {
        sz.erase(eltolas, 4);
        sz.insert(eltolas, "Randall" );
    }
    return sz;
}

int main(int argszama, char* mArg[])
{
    // létrehozunk egy sztringet két sztring összegeként
    cout << "sztring1 + sztring2 = "
         << (string("sztring 1") + string("sztring 2"))
         << endl;
    // létrehozunk egy tesztsztringet, majd töröljük az összes szóközt
    // belőle egyszeű metódusokkal
    string sz2("Ez egy tesztsztring");
    cout << "<" << sz2 << "> szóközök nélkül = <"
         << szokozokTorlese(sz2) << ">" << endl;
    // beszúrunk egy kifejezést egy meglévő mondat
    // közepére (a "<bp>" helyére)
    string sz3 = "Stephen <bp> Davis" ;
    cout << sz3 + " -> " + kifejezesBeszuras(sz3) << endl;
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
