// KÖLTSÉGVETÉS1 - Egy "funkcionális" Költségvetés program;
//                 befizetéseket és pénzfelvételeket fogad
//                 bizonyos számú számlán;
//                 végül kiírja a létrehozott
//                 számlákat
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// a számlák maximális száma
const int maxSzamlak = 10;

// a számlákat leíró adatok
unsigned szamlaSzam[maxSzamlak];
double   egyenleg[maxSzamlak];


// prototípusdeklarációk
void feldolgoz(unsigned szamlaSzam,
             double*  mEgyenleg);
void inicializal(unsigned* mSzamlaSzam,
          double*   mEgyenleg);

// main - összegyűjti a kezdeti be- és kimeneti összegeket
int main(int nArgSzama, char* mszArg[])
{
   cout << "Folytatás - C, befejezés - X:";
   // a ciklus addig fut, amíg meg nem adják
   int szamlakSzama = 0;         // a számlák számát

   // nem hozunk létre több számlát, mint amennyinek van hely
   cout << "Ez a program bankszámlákat hoz létre\n" << endl;
   while (szamlakSzama < maxSzamlak)
   {
       char tranzakcioTipus;
       cout << "Új számla létrehozása - C,"
            << " befejezés - X:";
       cin  >> tranzakcioTipus;

       // kilépünk, ha a felhasználó X-et ír be; különben...
       if (tranzakcioTipus == 'x' ||
           tranzakcioTipus == 'X')
       {
           break;
       }

       // ha a felhasználó C-t ír be, akkor...
       if (tranzakcioTipus == 'c' ||
           tranzakcioTipus == 'C')
       {
          // inicializáljuk az új számlát...
          // (átadjuk a címet, hogy a függvény tudja nekünk
          // módosítani az értéket)
          inicializal(&szamlaSzam[szamlakSzama],
               &egyenleg[szamlakSzama]);

          // megadjuk a tranzakció adatait
          feldolgoz(szamlaSzam[szamlakSzama],
                  &egyenleg[szamlakSzama]);

          // a következő számlára helyezzük át az indexet
          szamlakSzama++;
       }
   }

   // most kiírjuk az összegeket
   // először az egyes számlákhoz
   double osszeg = 0;
   cout << "Számlaadatok:\n";
   for (int i = 0; i < szamlakSzama; i++)
   {
      cout << "Számla egyenlege: "
           << szamlaSzam[i]
           << " = "
           << egyenleg[i]
           << endl;

      // az összes számla teljes összegének összesítése
      osszeg += egyenleg[i];
   }


   // most kiírjuk az összesített értéket
   cout << "Az összes számla együttes egyenlege = " << osszeg << endl;

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

// inicializal - egy számlát inicializál a számlaszám
//               beolvasásával és az egyenleg nullázásával
//               (itt mutatókat használ)
void inicializal(unsigned* mSzamlaSzam,
          double*   mEgyenleg)
{
   cout << "Add meg a számlaszámot:";
   cin  >> *mSzamlaSzam;
   *mEgyenleg = 0.0;
}

// feldolgoz - frissíti a számla egyenlegét a
//             felhasználó tranzakcióinak megadásával
//             (ebben a példában referenciaargumentumot használ -
//             ez ugyanazt eredményezi, mintha mutatót használnánk)
void feldolgoz(unsigned szamlaSzam,
             double*  mEgyenleg)
{
   cout << "Befizetéshez pozitív számot,\n"
        << "pénzfelvételhez negatív számot,\n"
        << " a befejezéshez nullát adj meg"
        << endl;

   double tranzakcio;
   while(true)
   {
      cout << ":";
      cin  >> tranzakcio;

      // kilépünk, ha a tranzakció nulla értékű
      if (tranzakcio == 0)
      {
          break;
      }

      // ha befizetés...
      if (tranzakcio > 0)
      {
         // ...hozzáadjuk az egyenleghez
         *mEgyenleg += tranzakcio;
      }

      // ...különben biztonsan pénzfelvétel
      else
      {
         // pénzfelvétel - egyszerűbb
         // pozitív számként kezelni a pénzfelvételt
         tranzakcio = -tranzakcio;
         if (*mEgyenleg < tranzakcio)
         {
            cout << "Nincs elég fedezet: az egyenleg "
                 << *mEgyenleg
                 << ", ellenőrizze a következőt: "
                 << tranzakcio
                 << "\n";
         }
         else
         {
            *mEgyenleg -= tranzakcio;
         }
      }
   }
}

