// SzamlakLancoltListaja - Szamla objektumok
//                         láncolt listáját tartja fenn

#ifndef _SZAMLAKLANCOLTLISTAJA_
#define _SZAMLAKLANCOLTLISTAJA_

// erre a szerencsétlen deklarációra azért van szükség, mert
// a Szamla nem a Listak névtér része. Ez a probléma
// megszűnik a követező verzióban, az V. részben szereplő Költségvetés4-ben.
class Szamla;
namespace Listak
{

    // előre deklaráljuk az osztályokat
    class SzamlakLancoltListaja;
    class Csomopont;

    // LancoltLista - egy Csomopont objektumokból álló láncolt lista
    class SzamlakLancoltListaja
    {
        public:
          SzamlakLancoltListaja() { mFej = 0; }
          void  csomopontHozzaadasa(Csomopont* mCsomopont);
          Csomopont* elsoCsomopont() { return mFej; }

        protected:
          Csomopont* mFej;
    };

    // Csomopont - egy láncolt lista egy csomópontja; minden Csomopont egy
    //             Szamla objektumra mutat
    class Csomopont
    {
        friend class SzamlakLancoltListaja;
      public:
        Csomopont(SzamlakLancoltListaja* mL, Szamla* mSzla)
        {
            mLista = mL;
            mKovetkezo = 0;
            mSzamla = mSzla;

            mL->csomopontHozzaadasa(this);
        }
        static Csomopont* elsoCsomopont(SzamlakLancoltListaja* mLista)
        {
            return mLista->elsoCsomopont();
        }

        Csomopont* kovetkezoCsomopont() { return mKovetkezo; }
        Szamla* aktualisSzamla() { return mSzamla; }

      protected:
        SzamlakLancoltListaja* mLista;
        Csomopont* mKovetkezo;
        Szamla* mSzamla;
    };
}
#endif
