// SzamlakLancoltListaja - Szamla objektumok
//                         láncolt listáját tartja fenn

#ifndef _SZAMLAKLANCOLTLISTAJA_
#define _SZAMLAKLANCOLTLISTAJA_

// az alap láncolt lista előzetes deklarációja
template <class T> class LancoltLista;

// Csomopont - egy láncolt lista egy csomópontja; minden Csomopont egy
//             Szamla objektumra mutat
template <class T> class Csomopont
{
    public:
        Csomopont(LancoltLista<T>* mL, T* mT)
        {
            mLista = mL;
            mKovetkezo = 0;
            mObjektum = mT;
        }

        Csomopont<T>* kovetkezo() { return mKovetkezo; }
        Csomopont<T>* kovetkezo(Csomopont<T>* mC) { mKovetkezo = mC; return mKovetkezo; }
        T* aktualis() { return mObjektum; }

    protected:
        LancoltLista<T>* mLista;
        Csomopont<T>* mKovetkezo;
        T* mObjektum;
};

// LancoltLista - Csomopont objektumok egy láncolt listája
template <class T> class LancoltLista
{
    public:
        LancoltLista<T>() { mElso = 0; }
        Csomopont<T>* elsoCsomopont() { return mElso; }
        Csomopont<T>* utolsoCsomopont()
        {
            // ha a lista üres, egyszerűen nullt adunk vissza
            if (mElso == 0)
            {
                return 0;   // üres lista; legyen az első
            }

            // különben megkeressük a lista utolsó elemét
            Csomopont<T>* mC = mElso;
            while(true)
            {
                Csomopont<T>* mKovetkezo = mC->kovetkezo();
                if (mKovetkezo == 0)
                {
                    break;
                }
                mC = mKovetkezo;
            }
            return mC;
        }

        void  csomopontHozzaadasa(Csomopont<T>* mCsomopont)
        {
            Csomopont<T>* mC = utolsoCsomopont();
            if (mC == 0)
            {
                mElso = mCsomopont;
            }
            else
            {
                mC->kovetkezo(mCsomopont);
            }
        }

    protected:
        Csomopont<T>* mElso;
};

#endif

